'
' Launcher for "portable-like" FreeQ IDEa with RapidQ 
' Possibly a pre-cursor to a true PortableApps.com Suite(TM) package
' although I don't think they would be interested!
' The files/file paths as per PortableApps software
'
'  AUTHOR: d_homans@yahoo.com.au
'    DATE: 17 May 2011
' VERSION: 0.2
'
$APPTYPE GUI
$TYPECHECK ON
$OPTION ICON "RapidDBG.ico"

CONST IDE_Path = "App\FreeQ\"

SUB Initialise
DEFINT i
DIM iniData AS QSTRINGLIST
DEFSTR tstr, tok, drvStr

    IF FILEEXISTS(IDE_Path+"FreeQ.exe")=0 THEN                      ' Not portable?
        MessageBox("Not a 'portable' environment!","RQPortable",&h10)
        END
    END IF
    ' First-time run, the ini file doesn't exist
    IF FILEEXISTS(IDE_Path+"FreeQ.ini")=0 THEN EXIT SUB             ' First time run?

    drvStr=UCASE$(LEFT$(CURDIR$,3))                                 ' Current drive
    iniData.LoadFromFile(IDE_Path+"FreeQ.ini")
    FOR i=0 TO iniData.ItemCount-1
        tstr=UCASE$(FIELD$(iniData.Item(i),"=",1))
        IF tstr="COMPILERPATH" THEN
            tstr=LTRIM$(UCASE$(FIELD$(iniData.Item(i),"=",2)))
            IF (tstr="") OR (drvStr=LEFT$(tstr,3)) THEN             ' Current drive ok or path...
                EXIT SUB                                            ' ...not set - do nothing    
            ELSE
                EXIT FOR
            END IF
        END IF
    NEXT i
    ' Update drive paths in ini file, but NOT harddisk C:\
    FOR i=0 TO iniData.ItemCount-1
        tstr=iniData.Item(i)
        tok=LTRIM$(FIELD$(tstr,"=",2))
        IF tok <> "" THEN
            IF (INSTR(tok,":")=2) AND (UCASE$(LEFT$(tok,1))<>"C") THEN
                tok=RIGHT$(tok,LEN(tok)-3)
                tok=drvStr+tok
                iniData.Item(i)=FIELD$(tstr,"=",1)+"="+tok
            END IF
        END IF
    NEXT i
    iniData.SaveToFile(IDE_Path+"FreeQ.ini")
END SUB

' Start here, check/update the "portable" environment
Initialise

CHDIR IDE_Path
RUN "FreeQ.exe"                                                     ' RUN FreeQ IDE and terminate

END
